package com.example;

import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.TableGenerator;
import javax.persistence.Version;

@MappedSuperclass
public class Animal {

	@Version
	private int version;

	@Id
	@TableGenerator(name = "ANIMAL_SEQ")
	@GeneratedValue(strategy = GenerationType.TABLE, generator = "ANIMAL_SEQ")
	private String id;

	private String name;

	public Animal() {
		super();
	}

	public Animal(String name) {
		this.name = name;
	}

	public String getId() {
		return id;
	}

	public int getVersion() {
		return version;
	}

	protected void setVersion(int version) {
		this.version = version;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

}
