package com.example;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Example {

	public static void main(String[] args) {
		interfaceProblem();
	}

	private static void interfaceProblem() {
		EntityManagerFactory emf = Persistence
				.createEntityManagerFactory("example");

		EntityManager em = emf.createEntityManager();
		try {
			em.getTransaction().begin();

			Animal princess = new Cat("Princess", 'F', 7.4f);
			Animal blackie = new Cat("Blackie", 'M', 7.6f);

			em.persist(princess);
			em.persist(blackie);

			em.getTransaction().commit();

			List<Cat> cats = em.createNamedQuery(ICat.SELECT_ALL)
					.getResultList();

			for (Animal c : cats) {
				System.out.println(c.getName());
			}
		} catch (Exception ex) {
			if (em.getTransaction().isActive()) {
				em.getTransaction().rollback();
			}
			ex.printStackTrace();
		} finally {
			em.close();
		}
	}

//	private static void someOldExample() {
//		EntityManagerFactory emf = Persistence
//				.createEntityManagerFactory("example");
//
//		EntityManager em = emf.createEntityManager();
//		EntityManager em2 = emf.createEntityManager();
//		EntityManager em3 = emf.createEntityManager();
//		try {
//
//			System.out.println("start");
//			em.getTransaction().begin();
//
//			Animal princess = new Cat("Princess", 'F', 7.4f);
//			Animal blackie = new Cat("Blackie", 'M', 7.6f);
//
//			em.persist(princess);
//			em.persist(blackie);
//
//			em.getTransaction().commit();
//
//			List<Cat> cats = em.createNamedQuery(ICat.SELECT_ALL)
//					.getResultList();
//
//			for (Animal c : cats) {
//				System.out.println(c.getName());
//
//				// System.out.println("1 " + c.getName());
//				// em.getTransaction().begin();
//				// c.setName("Sh...t");
//				// System.out.println("2 " + c.getName());
//				// em.getTransaction().rollback();
//				// System.out.println("3 " + c.getName());
//			}
//
//			em.getTransaction().begin();
//
//			Animal c = em.find(Cat.class, "1");
//
//			c.setName("Fero");
//			System.out.println(c.getName());
//			em.getTransaction().commit();
//
//			em.getTransaction().begin();
//			c = em.find(Cat.class, "1");
//			System.out.println(">" + c.getName());
//			c.setName("Fero2");
//			System.out.println(">>" + c.getName());
//			em.getTransaction().rollback();
//			System.out.println(">>>" + c.getName());
//			c = em.find(Cat.class, "1");
//			System.out.println(">>>>" + c.getName());
//
//			em2.getTransaction().begin();
//			Animal c2 = em2.find(Cat.class, "1");
//			c2.setName("Duro");
//			System.out.println(c2.getName());
//			em2.getTransaction().commit();
//
//			System.out.println("Result:");
//			cats = em3.createQuery("SELECT c FROM Cat c").getResultList();
//			for (Animal cc : cats) {
//				System.out.println(cc.getName());
//			}
//
//		} catch (Exception ex) {
//			if (em.getTransaction().isActive()) {
//				em.getTransaction().rollback();
//			}
//			if (em2.getTransaction().isActive()) {
//				em2.getTransaction().rollback();
//			}
//			ex.printStackTrace();
//		} finally {
//			em.close();
//		}
//	}
}
